package ru.mobilab.gamesample;

import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Rect;

public class ElaineAnimated {
	private static final String TAG = ElaineAnimated.class.getSimpleName();

	private Bitmap bitmap;		//    
	private Rect sourceRect;	//    bitmap,    
	private int frameNr;		//    
	private int currentFrame;	//  
	private long frameTicker;	//    
	private int framePeriod;	//        (1000/fps)

	private int spriteWidth;	//   ( )
	private int spriteHeight;	//  

	private int x;				// X   (   )
	private int y;				// Y   (   )
	
	public ElaineAnimated(Bitmap bitmap, int x, int y, int width, int height, int fps, int frameCount) {
		this.bitmap = bitmap;
		this.x = x;
		this.y = y;
		currentFrame = 0;
		frameNr = frameCount;
		spriteWidth = bitmap.getWidth() / frameCount;
		spriteHeight = bitmap.getHeight();
		sourceRect = new Rect(0, 0, spriteWidth, spriteHeight);
		framePeriod = 1000 / fps;
		frameTicker = 0l;
	}
	
	public void update(long gameTime) {
		if (gameTime > frameTicker + framePeriod) {
			frameTicker = gameTime;
			//    
			currentFrame++;
			if (currentFrame >= frameNr) {
				//        
				//  ,     
				currentFrame = 0; 
			}
		}
		//      ,   
		this.sourceRect.left = currentFrame * spriteWidth;
		this.sourceRect.right = this.sourceRect.left + spriteWidth;
	}
	
	public void draw(Canvas canvas) {
		// ,   
		Rect destRect = new Rect(x, y, x + spriteWidth, y + spriteHeight);
		canvas.drawBitmap(bitmap, sourceRect, destRect, null);

		canvas.drawBitmap(bitmap, 20, 150, null);
		Paint paint = new Paint();
		paint.setARGB(50, 0, 255, 0);
		canvas.drawRect(20 + (currentFrame * destRect.width()), 150, 20 + (currentFrame * destRect.width()) + destRect.width(), 150 + destRect.height(),  paint);
		
	}
}
